//---------------------------------------------------------------------------
#ifndef MainMDIH
#define MainMDIH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ComCtrls.hpp>
#include <explbtn.hpp>
#include "FileMan.h"
#include "Global.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
   TMenuItem *N1;
   TMenuItem *N2;
   TMenuItem *N3;
   TMenuItem *N4;
   TMenuItem *N6;
   TMenuItem *N8;
   TMenuItem *N9;
 	 TMenuItem *EdUndoBrk;
	 TMenuItem *EdPasteBrk;
   TMenuItem *ClipboardN1Item;
	 TMenuItem *EdMenu;
	 TMenuItem *EdUndo;
	 TMenuItem *EdCut;
	 TMenuItem *EdCopy;
	 TMenuItem *EdPaste;
	 TMenuItem *EdSelectAll;
   TPanel *Panel1;
   TOpenDialog *OpenDialog;
   TSaveDialog *SaveDialog;
   TMainMenu *MainMenu;
   TMenuItem *FileMenu;
   TMenuItem *FileOpenItem;
   TMenuItem *FileSendMessageItem;
   TMenuItem *FileQueueItem;
   TMenuItem *FileOpenQueueItem;
   TMenuItem *FileTemplatesItem;
   TMenuItem *FileSaveItem;
   TMenuItem *FileSaveAsItem;
   TMenuItem *FileSaveAsDefaultItem;
   TMenuItem *FileSaveAsDefMessageItem;
   TMenuItem *FileSaveAsDefArticleItem;
   TMenuItem *FileSaveAsTemplateItem;
   TMenuItem *FileNewArticleItem;
   TMenuItem *FileNewNoteItem;
   TMenuItem *FileMiscMessagesItem;
   TMenuItem *FilePrintItem;
   TMenuItem *FilePackDatabaseItem;
   TMenuItem *FileSecureModeItem;
   TMenuItem *FileExitItem;
   TMenuItem *FileNewMenu;
   TMenuItem *FileNewMessageItem;
   TMenuItem *FileNotesItem;
   TMenuItem *ViewMenu;
   TMenuItem *ViewMListTxtItem;
   TMenuItem *ViewPubringMixItem;
   TMenuItem *ViewType2ListItem;
   TMenuItem *ViewRListTxtItem;
   TMenuItem *ViewPubringAscItem;
   TMenuItem *ToolsMenu;
   TMenuItem *ToolsAddressBookItem;
   TMenuItem *ToolsRemailersItem;
   TMenuItem *ToolsUpdateonSendItem;
   TMenuItem *MailboxMenu;
   TMenuItem *MailboxMailboxesItem;
   TMenuItem *ClipboardMenu;
   TMenuItem *ClipboardFollowupItem;
   TMenuItem *ClipboardReplyItem;
   TMenuItem *ViewErrLogItem;
   TMenuItem *WindowMenu;
   TMenuItem *WindowTileItem;
   TMenuItem *WindowCascadeItem;
   TMenuItem *WindowArrangeIconsItem;
   TMenuItem *HelpMenu;
   TMenuItem *HelpAboutItem;
   TStatusBar *StatusBar;
   TBevel *Bevel1; TBevel *Bevel2; TBevel *Bevel3; TBevel *Bevel4;
   TMenuItem *FileOpenDataItem;
   TMenuItem *ViewMixcfgItem;
   TMenuItem *FileProblemsItem;
   TMenuItem *HelpGettingStartedItem;
   TMenuItem *OpenMenu;
   TMenuItem *Preferences1;
   TMenuItem *MailboxOutboxItem;
   TMenuItem *MailboxNewItem;
   TTimer *SendTimer;
   TMenuItem *FileCheckMailItem;
   TMenuItem *MailboxInboxItem;
   TMenuItem *FileSMTPLogItem;
   TMenuItem *ClipboardReceiveItem;
   TMenuItem *HelpN7Item;
   TMenuItem *HelpUpdateItem;
   TMenuItem *ToolsPopAccountsItem;
   TMenuItem *FileSessionLogsItem;
   TMenuItem *SessionLogsPOP3Item;
   TMenuItem *SessionLogsSMTPItem;
   TMenuItem *N7;
   TMenuItem *FileNewBugReport;
   TMenuItem *PgpMenu;
   TMenuItem *PgpLaunchKeysItem;
   TMenuItem *PgpPreferencesItem;
   TTimer *Timer1;
   TMenuItem *N12;
   TMenuItem *ToolsOptionsItems;
   TBevel *Bevel7;
   TCheckBox *UpdateStatsBox;
   TOfficeButton *OfficeButton1;
   TExplorerButton *ExplorerButton1;
   TOfficeButton *NewMessageBtn;
   TOfficeButton *NewArticleBtn;
   TOfficeButton *OfficeButton2;
   TOfficeButton *OpenTemplateBtn;
   TOfficeButton *OpenDraftBtn;
   TOfficeButton *OpenNoteBtn;
   TOfficeButton *OpenQueueBtn;
   TBevel *Bevel8;
   TOfficeButton *OpenProbsBtn;
   TOfficeButton *CheckMailBtn;
   TBevel *Bevel9;
   TOfficeButton *OfficeButton3;
   TBevel *Bevel10;
   TOfficeButton *AddressBookBtn;
   TOfficeButton *RemailerBtn;
   TBevel *Bevel12;
   TOfficeButton *InBoxBtn;
  TOfficeButton *OutBoxBtn;
   TOfficeButton *OptionsBtn;
   TMenuItem *ViewType1ListItem;
   TMenuItem *N13;
   TMenuItem *ViewClearItem;
   TMenuItem *SessionLogsErrorCheckItem;
	 TMenuItem *EdSelectBrk;
	 TMenuItem *EdInsertText;
	 TMenuItem *EdInsertFilename;
	 TMenuItem *EdInsertBrk;
	 TMenuItem *EdWordWrap;
	 TMenuItem *EdWordWrapNote;
	 TMenuItem *EdWordWrapMessage;
	 TMenuItem *EdPasteQuote;
   TMenuItem *ToolsMixManItem;
   TMenuItem *ToolsCpunkManItem;
   TMenuItem *ToolsPgpKeyItem;
   TOfficeButton *MixKeysBtn;
   TOfficeButton *CpkKeysBtn;
   TOfficeButton *NewBtn;
   TPopupMenu *PopupMenu;
   TMenuItem *PopMessageItem;
   TMenuItem *PopUsenetItem;
   TMenuItem *PopNoteItem;
   TMenuItem *PopBugItem;
   TBevel *Bevel5;
   TMenuItem *N14;
   TOfficeButton *PgpKeysBtn;
   TBevel *Bevel6;
   TBevel *Bevel11;
   TMenuItem *KeyringMenu;
   TMenuItem *KeyringSaveItem;
   TMenuItem *KeyringRefreshItem;
   TMenuItem *KeyringImportItem;
   TMenuItem *N15;
   TMenuItem *KeyringDisableItem;
   TMenuItem *KeyringDeleteItem;
   TMenuItem *KeyringConfigItem;
   TMenuItem *KeyringOpenItem;
   TMenuItem *KeyringConfigAllItem;
   TMenuItem *KeyringConfigConfigItem;
   TMenuItem *KeyringConfigKeyItem;
   TMenuItem *KeyringConfigStatsItem;
   TMenuItem *KeyringConfigHelpItem;
   TMenuItem *N17;
   TMenuItem *KeyringOpenPubringmixItem;
   TMenuItem *KeyringOpenType2Item;
   TMenuItem *KeyringOpenMlistItem;
   TMenuItem *KeyringOpenPubringascItem;
   TMenuItem *KeyringOpenType1Item;
   TMenuItem *KeyringOpenRlistItem;
   TMenuItem *KeyringOpenProblemmixItem;
   TMenuItem *KeyringOpenProblemcpkItem;
   TMenuItem *N16;
  TMenuItem *ToolsKeyringsItem;
  TMenuItem *ToolsMixKeyringItem;
  TMenuItem *N10;
  TMenuItem *Applicationdirectory1;
  TMenuItem *N11;
  TMenuItem *OpenMixDirectoryItem;
  TMenuItem *KeyringClearItem;
  TMenuItem *KeyringNewKeyItem;
  TMenuItem *Contents1;
  TImageList *ImageList1;
  TMenuItem *KeyringRefreshMenu;
  TMenuItem *KeyringRefreshDiskItem;
  TMenuItem *KeyringRefreshPGP6Item;
  TMenuItem *KeyringSaveMenu;
  TMenuItem *KeyringSaveDiskItem;
  TMenuItem *KeyringSavePGP6Item;
  TMenuItem *N5;
  TMenuItem *SessionLogs1;
  TMenuItem *ErrorCheck1;
  TMenuItem *ViewLogsPop3;
  TMenuItem *SMTP1;
	TMenuItem *ViewChainLogItem;
  TOfficeButton *HelpBtn;
  TMenuItem *ToolsNymWizItem;
  TMenuItem *N18;
  TOfficeButton *NymWizBtn;
  TBevel *Bevel13;
  TTimer *Timer2;
  TOfficeButton *FingerBtn;
  TMenuItem *ToolsFingerItem;
	TMenuItem *ViewHistoryMenu;
	TMenuItem *QuickSilver1;
	TMenuItem *N19;
	TMenuItem *ManualTxt;
	TMenuItem *N20;
	TMenuItem *nymaliasnethelpfile1;
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall ViewMixmasterFileItemClick(TObject *Sender);
   void __fastcall ToolsAddressBookItemClick(TObject *Sender);
   void __fastcall ToolsRemailersItemClick(TObject *Sender);
   void __fastcall ToolsUpdateonSendItemClick(TObject *Sender);
   void __fastcall FileNotesItemClick(TObject *Sender);
   void __fastcall MailboxMailboxesItemClick(TObject *Sender);
   void __fastcall FileNewMessageItemClick(TObject *Sender);
   void __fastcall FileNewArticleItemClick(TObject *Sender);
   void __fastcall FileMenuClick(TObject *Sender);
   void __fastcall FileSecureModeItemClick(TObject *Sender);
   void __fastcall FilePackDatabaseItemClick(TObject *Sender);
   void __fastcall FileOpenQueueItemClick(TObject *Sender);
   void __fastcall FileQueueItemClick(TObject *Sender);
   void __fastcall FileOpenItemClick(TObject *Sender);
   void __fastcall FileExitItemClick(TObject *Sender);
   void __fastcall FileSaveAsItemClick(TObject *Sender);
   void __fastcall FileSaveItemClick(TObject *Sender);
   void __fastcall FileSaveAsDefMessageItemClick(TObject *Sender);
   void __fastcall FileSaveAsDefArticleItemClick(TObject *Sender);
   void __fastcall FileSaveAsTemplateItemClick(TObject *Sender);
   void __fastcall FilePrintItemClick(TObject *Sender);
   void __fastcall FileNewNoteItemClick(TObject *Sender);
   void __fastcall FileSendMessageItemClick(TObject *Sender);
   void __fastcall FileTemplatesItemClick(TObject *Sender);
   void __fastcall WindowItemClick(TObject *Sender);
   void __fastcall WindowMenuClick(TObject *Sender);
   void __fastcall ClipboardMenuClick(TObject *Sender);
   void __fastcall ClipboardReplyItemClick(TObject *Sender);
   void __fastcall ClipboardFollowupItemClick(TObject *Sender);
   void __fastcall HelpAboutItemClick(TObject *Sender);
   void __fastcall EditBtnClick(TObject *Sender);
   void __fastcall StatusBarResize(TObject *Sender);
   void __fastcall FormDestroy(TObject *Sender);
   void __fastcall UpdateStatsBoxClick(TObject *Sender);
   void __fastcall Panel1Resize(TObject *Sender);
   void __fastcall FileOpenDataItemClick(TObject *Sender);
   void __fastcall FileProblemsItemClick(TObject *Sender);
   void __fastcall ViewLastSMTPLogItemClick(TObject *Sender);
   void __fastcall ViewMenuClick(TObject *Sender);
   void __fastcall HelpGettingStartedItemClick(TObject *Sender);
   void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
   void __fastcall Preferences1Click(TObject *Sender);
   void __fastcall ViewErrLogItemClick(TObject *Sender);
   void __fastcall MailboxOutboxItemClick(TObject *Sender);
   void __fastcall MailboxNewItemClick(TObject *Sender);
   void __fastcall FileSMTPLogItemClick(TObject *Sender);
   void __fastcall SendTimerTimer(TObject *Sender);
   void __fastcall FilePOP3LogItemClick(TObject *Sender);
   void __fastcall FileCheckMailItemClick(TObject *Sender);
   void __fastcall MailboxInboxItemClick(TObject *Sender);
   void __fastcall CheckBtnClick(TObject *Sender);
   void __fastcall ClipboardReceiveItemClick(TObject *Sender);
   void __fastcall HelpUpdateItemClick(TObject *Sender);
   void __fastcall ToolsPopAccountsItemClick(TObject *Sender);
   void __fastcall HelpQuickPop3ItemClick(TObject *Sender);
   void __fastcall HelpMenuClick(TObject *Sender);
   void __fastcall FileNewBugReportClick(TObject *Sender);
   void __fastcall Timer1Timer(TObject *Sender);
   void __fastcall ToolsOptionsItemsClick(TObject *Sender);
   void __fastcall InBoxBtnClick(TObject *Sender);
   void __fastcall OutBoxBtnClick(TObject *Sender);
   void __fastcall OptionsBtnClick(TObject *Sender);
   void __fastcall HelpQuickPgpItemClick(TObject *Sender);
   void __fastcall ViewClearItemClick(TObject *Sender);
   void __fastcall SessionLogsErrorCheckItemClick(TObject *Sender);
   void __fastcall ViewChainLogClick(TObject *Sender);
   void __fastcall EdMenuActionClick(TObject *Sender);
   void __fastcall EdMenuClick(TObject *Sender);
   void __fastcall ToolsMixManItemClick(TObject *Sender);
   void __fastcall ToolsCpunkManItemClick(TObject *Sender);
   void __fastcall KeyringMenuClick(TObject *Sender);
   void __fastcall KeyringOpenItemClick(TObject *Sender);
   void __fastcall KeyringSaveItemClick(TObject *Sender);
   void __fastcall KeyringRefreshItemClick(TObject *Sender);
   void __fastcall KeyringImportItemClick(TObject *Sender);
   void __fastcall KeyringDisableItemClick(TObject *Sender);
   void __fastcall KeyringDeleteItemClick(TObject *Sender);
   void __fastcall KeyringConfigItemClick(TObject *Sender);
   void __fastcall KeyringOpenDocItemClick(TObject *Sender);
  void __fastcall ToolsPgpKeyItemClick(TObject *Sender);
  void __fastcall Applicationdirectory1Click(TObject *Sender);
  void __fastcall OpenMixDirectoryItemClick(TObject *Sender);
  void __fastcall KeyringClearItemClick(TObject *Sender);
  void __fastcall KeyringNewKeyItemClick(TObject *Sender);
  void __fastcall Contents1Click(TObject *Sender);
  void __fastcall KeyringRefreshPGP6ItemClick(TObject *Sender);
  void __fastcall KeyringRefreshDiskItemClick(TObject *Sender);
  void __fastcall KeyringSaveDiskItemClick(TObject *Sender);
  void __fastcall KeyringSavePGP6ItemClick(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall ToolsNymWizItemClick(TObject *Sender);
  void __fastcall NymWizBtnClick(TObject *Sender);
  void __fastcall Timer2Timer(TObject *Sender);
  void __fastcall ToolsFingerItemClick(TObject *Sender);
	
	
	void __fastcall ManualTxtClick(TObject *Sender);
private:// User declarations
   void __fastcall OnAppActivate(TObject *Sender);
   void __fastcall ShowHint(TObject *Sender);
public:	// User declarations
   int entropy;
   TShiftState LastShiftState;
   bool GetThatMix;
   TDateTime DatTime;
   TDateTime PgpTime;
   AnsiString winpos;
   TStrings *Message;
   AnsiString RunProgramOnExit;
   TStringList *ProcessLog,*ErrorLog;
   Graphics::TBitmap *ProbQueueBitmap;
   __fastcall TMainForm(TComponent* Owner);
   __fastcall virtual ~TMainForm();
   void __fastcall DisplayStatus(AnsiString &status, AnsiString &other=AnsiString(""));
   void __fastcall DisplayXY(long X, long Y);
   bool __fastcall IsEncrypted();
   void __fastcall OnActiveFormChange(TObject *Sender);
   void __fastcall MailboxItemOnClick(TObject *Sender);
   void __fastcall LoadMailboxMenu();
   void __fastcall SetMenus(bool children=true);
   void __fastcall EnableProbQueueButton(bool enable);
   void __fastcall NewMessage();
   void __fastcall NewArticle();
   void __fastcall FileOpen(AnsiString fromSection);
   void __fastcall FileSave(AnsiString toSection);
   void __fastcall SetButtons(bool enable);
   void __fastcall ShowInitValues(); // sanity check on init values
   bool __fastcall CheckRegkeyExists();
   bool __fastcall CheckAppiniExists();
   void __fastcall CheckTemplateHostFrom();
   void __fastcall ViewHistoryMenuItemOnClick(TObject *Sender);
   TMenuItem* __fastcall NewHistoryMenuItem(AnsiString Caption);
   HINSTANCE __fastcall CheckMixmasterInstall(bool &shutdown);
   void __fastcall SetNoMixmaster(); // disables menus, btns, etc if no mix
   void __fastcall SetNoCyberpunk();
   void __fastcall SetCyberpunk();
   HINSTANCE __fastcall CheckQSNymInstall();
   void __fastcall SetNoNyms();
   HINSTANCE __fastcall CheckQSPgpInstall();
   void __fastcall SetNoPgp();
   HINSTANCE __fastcall CheckQSPgpSdkInstall();
   void __fastcall SetNoPgpSdk();
   HINSTANCE __fastcall CheckQSPop3Install();
   void __fastcall SetNoPop3();
   void __fastcall SavePOP3Log(WORD count, TStrings *log);
   HINSTANCE __fastcall CheckUPDateInstall();
   //bool __fastcall HasUpd();
   void __fastcall SafeStoreMixRandBin();
   bool __fastcall CheckMixrndExists();
   bool __fastcall MixZipExists();
   void __fastcall SetEditMenu();
   void __fastcall SetKeyringMenu();
   // Secure Mode
   bool __fastcall UnSecureData(TDataBuf *password);
   bool __fastcall SecureData(TDataBuf *password);
   // message functions
   void virtual __fastcall WMQueueChange(TMessage& Msg);
   void virtual __fastcall WMProblemChange(TMessage& Msg);
   void virtual __fastcall WMUpdateChecked(TMessage& Msg);
   void virtual __fastcall WMUpdateEnable(TMessage& Msg);
   void virtual __fastcall WMSetButtons(TMessage& Msg);
   void virtual __fastcall WMGetErrorLog(TMessage& Msg);
   void virtual __fastcall WMOpenProblems(TMessage& Msg);
   void virtual __fastcall WMOpenQueue(TMessage& Msg);
   void virtual __fastcall WMCheckUpdate(TMessage& Msg);
   void virtual __fastcall WMLoadMailboxMenu(TMessage& Msg);
   void virtual __fastcall WMInsertFilename(TMessage& Msg);
   void virtual __fastcall WMDisplayXY(TMessage& Msg);
   void virtual __fastcall WMIncomingMail(TMessage& Msg);
   void virtual __fastcall WMOpenInbox(TMessage& Msg);
   void virtual __fastcall WMStorePoplog(TMessage& Msg);
   void virtual __fastcall WMPopAccounts(TMessage& Msg);
   void virtual __fastcall WMSendMail(TMessage& Msg);
   void virtual __fastcall WMSetWinCursor(TMessage& Msg);
   void virtual __fastcall WMDatRequest(TMessage& Msg);
   void virtual __fastcall WMShowStatus(TMessage& Msg);
   void virtual __fastcall WMSaveQuit(TMessage& Msg);
   void virtual __fastcall WMSecureData(TMessage& Msg);
   void virtual __fastcall WMOpenAddresses(TMessage& Msg);
   void virtual __fastcall WMHelpWinPos(TMessage& Msg);
   void virtual __fastcall WMOpenKeyMan(TMessage& Msg);
   void virtual __fastcall WMGetSessionKey(TMessage& Msg);
   void virtual __fastcall WMWipeFile(TMessage& Msg);
   void virtual __fastcall WMOpenNymMessage(TMessage& Msg);
   void virtual __fastcall WMGetMergeMessage(TMessage& Msg);
   void virtual __fastcall WMUpdatePgpKeyWin(TMessage& Msg);
   // message map
   BEGIN_MESSAGE_MAP
   MESSAGE_HANDLER(WM_QUEUECHANGE,TMessage,WMQueueChange)
   MESSAGE_HANDLER(WM_PROBLEMCHANGE,TMessage,WMProblemChange)
   MESSAGE_HANDLER(WM_UPDATECHECKED,TMessage,WMUpdateChecked)
   MESSAGE_HANDLER(WM_UPDATEENABLE,TMessage,WMUpdateEnable)
   MESSAGE_HANDLER(WM_CHECKUPDATE,TMessage,WMCheckUpdate)
   MESSAGE_HANDLER(WM_SETBUTTONS,TMessage,WMSetButtons)
   MESSAGE_HANDLER(WM_GETERRORLOG,TMessage,WMGetErrorLog)
   MESSAGE_HANDLER(WM_OPENPROBLEMS,TMessage,WMOpenProblems)
   MESSAGE_HANDLER(WM_OPENQUEUE,TMessage,WMOpenQueue)
   MESSAGE_HANDLER(WM_LOADBOXMENU,TMessage,WMLoadMailboxMenu)
   MESSAGE_HANDLER(WM_INSERTFILENAME,TMessage,WMInsertFilename)
   MESSAGE_HANDLER(WM_DISPLAYXY,TMessage,WMDisplayXY)
   MESSAGE_HANDLER(WM_INCOMINGMAIL,TMessage,WMIncomingMail)
   MESSAGE_HANDLER(WM_OPENINBOX,TMessage,WMOpenInbox)
   MESSAGE_HANDLER(WM_STOREPOPLOG,TMessage,WMStorePoplog)
   MESSAGE_HANDLER(WM_SENDMAIL,TMessage,WMSendMail)
   MESSAGE_HANDLER(WM_SETWINCURSOR,TMessage,WMSetWinCursor)
   MESSAGE_HANDLER(WM_DATREQUEST,TMessage,WMDatRequest)
   MESSAGE_HANDLER(WM_SHOWSTATUS,TMessage,WMShowStatus)
   MESSAGE_HANDLER(WM_SAVEQUIT,TMessage,WMSaveQuit)
   MESSAGE_HANDLER(WM_OPENADDRESSES,TMessage,WMOpenAddresses)
   MESSAGE_HANDLER(WM_HELPWINPOS,TMessage,WMHelpWinPos)
   MESSAGE_HANDLER(WM_OPENKEYMAN,TMessage,WMOpenKeyMan)
   MESSAGE_HANDLER(WM_GETSESSIONKEY,TMessage,WMGetSessionKey)
   MESSAGE_HANDLER(WM_WIPEFILE,TMessage,WMWipeFile)
   MESSAGE_HANDLER(WM_OPENNYMMESSAGE,TMessage,WMOpenNymMessage)
   MESSAGE_HANDLER(WM_GETMERGEMESSAGE,TMessage,WMGetMergeMessage)
   MESSAGE_HANDLER(WM_UPDATEPGPKEYWIN,TMessage,WMUpdatePgpKeyWin)
   END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern TDataBuf *MasterPassword;
extern TDataBuf *Passwords;
extern TMainForm *MainForm;
extern bool MessageTesting;
//---------------------------------------------------------------------------
#endif
